unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Gauges, iHtml, Buttons, ComCtrls, ExtCtrls,
  VBScript_RegExp_55_TLB;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Status: TStatusBar;
    PageMain: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Page1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    LblUrlNum: TLabel;
    MemNumbers: TMemo;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    LblUrlLoto: TLabel;
    MemLoto: TMemo;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    MemPre: TMemo;
    TabSheet5: TTabSheet;
    MemMain: TMemo;
    procedure N2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    FMemBuf: TMemoryStream;
    FStrBuf: TStrings;
    FStrBuf2: TStrings;
    FDataFileUrl: TStrings;
    FGauge: TGauge;
    FRegBuf: TRegExp;
    procedure ShowStatus(const Msg: string);
    procedure Progress(const MaxValue, CurValue: integer; const Mode: TProgressMode);

    procedure GetFiles(const TopPageUrl: string; MsgBuf: TStrings);
    function VisitAction(const Path: string; const IsFile: Boolean;
                         const Level: integer; var DigDir: Boolean): Boolean;
    function VisitActionMain(const Path: string; const IsFile: Boolean;
                         const Level: integer; var DigDir: Boolean): Boolean;
    procedure AnalizeLotoOld();
    procedure AnalizeLoto6Old();
    procedure AnalizeLotoNew();
    procedure AnalizeLoto6New();
    procedure AnalizeNumbersOld();
    procedure AnalizeNumbers3New();
    procedure AnalizeNumbers4New();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    iMisc, DateUtils;

{$R *.dfm}

var
    DATA_DIR: string;
    WORK_DIR: string;
    RSLT_DIR: string;

//  ---------------------------------------------------------------------------
//  񃁃bZ[W_CAO
procedure SimpleMessage(AMsg: string);
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbOK]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Dialog.ShowModal;
    finally
        Dialog.Free;
    end;

    Application.RestoreTopMosts;
end;

//  ---------------------------------------------------------------------------
//  mFbZ[W_CAO
function SimpleYesNo(AMsg: string): Boolean;
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbYes, mbNo]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Result := (Dialog.ShowModal = mrYes);
    finally
        Dialog.Free;
    end;

    Application.RestoreTopMosts;
end;

//  ---------------------------------------------------------------------------
//  URL̎t@Co
function ExtractUrlFileName(const URL: string): string;
var
    index: integer;
begin
    index := LastDelimiter('/', URL);
    Result := Copy(URL, index + 1, Length(URL));
end;

//  ---------------------------------------------------------------------------
//  URL̎fBNgo
function ExtractUrlFilePath(const URL: string): string;
var
    index: integer;
begin
    index := LastDelimiter('/', URL);
    Result := Copy(URL, 1, index);
end;

//  ---------------------------------------------------------------------------
//  bZ[W\
procedure ShowMsg(const Msg: string; Target: TStrings);
begin
    Target.Add(FormatDateTime('yyyy/mm/dd hh:mm:ss', Now()) + ' >' + Msg);
end;

//------------------------------------------------------------------------------
//  t@C/tH_̃R[obN֐
type
    TVisitorProc = function(const Path: string;     //  pX
                            const IsFile: Boolean;  //  t@Cǂ
                            const Level: integer;   //  @i񂾃x
                            var DigDir: Boolean)    //  tH_̏ꍇ@邩ǂ
                            : Boolean of object;    //  f true

//------------------------------------------------------------------------------
//  ֐
procedure VisitDirectory(const DirPath: string; const Level: integer; Proc: TVisitorProc);
var
    Rec: TSearchRec;
    Path: string;
    DigDir, Cancel: Boolean;
begin
    //  \ t
    Path := IncludeTrailingPathDelimiter(DirPath);
    //  񌟍
    if FindFirst(Path  + '*.*', faAnyFile, Rec) = 0 then
    begin
        //  
        try
            repeat
                //  tH_
                if (Rec.Attr and faDirectory > 0) and (Rec.Name <> '.') and (Rec.Name <> '..') then
                begin
                    //  ʒm
                    DigDir := true;
                    Cancel := Proc(Path + Rec.Name, false, Level, DigDir);
                    //  LZ̏ꍇ
                    if Cancel then break;
                    //  Ɍ@ꍇ
                    if DigDir then VisitDirectory(Path + Rec.Name, Level + 1, Proc);
                end
                //  t@C
                else
                if (Rec.Name <> '.') and (Rec.Name <> '..') then
                begin
                    //  ʒm
                    Cancel := Proc(Path + Rec.Name, true, Level, DigDir);
                    //  LZ̏ꍇ
                    if Cancel then break;
                end;
            until
                (FindNext(Rec) <> 0)
            ;
        //  
        finally
            FindClose(Rec);
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  Xe[^Xo[ɕ\
procedure TForm1.ShowStatus(const Msg: string);
begin
    Status.Panels[1].Text := Msg;
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TForm1.FormCreate(Sender: TObject);
begin
    FGauge := TGauge.Create(Self);
    FGauge.Parent := Status;
    FGauge.Left := 2;
    FGauge.Top := 2;
    FGauge.Width := Status.Panels[0].Width - 3;
    FGauge.Height := Status.Height - 3;
    FGauge.BackColor := Status.Color;
    FGauge.ForeColor := clBlack;
    FGauge.Show();

    FMemBuf := TMemoryStream.Create;
    FStrBuf := TStringList.Create;
    FStrBuf2 := TStringList.Create;
    FRegBuf := TRegExp.Create(nil);
    FRegBuf.Global := true;             //  SΏۂƂ
    FDataFileUrl := TStringList.Create;
end;

//  ---------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
//    FGauge.Free;
    FDataFileUrl.Free;
    FRegBuf.Free;
    FStrBuf2.Free;
    FStrBuf.Free;
    FMemBuf.Free;
end;

//  ---------------------------------------------------------------------------
//  ۑtH_J
procedure TForm1.N2Click(Sender: TObject);
begin
    SimpleShellExecute(DATA_DIR);
end;

//  ---------------------------------------------------------------------------
//  I
procedure TForm1.Exit1Click(Sender: TObject);
begin
    Self.Close();
end;

//  ---------------------------------------------------------------------------
//  i\
procedure TForm1.Progress(const MaxValue, CurValue: integer; const Mode: TProgressMode);
var
    Buf: string;
begin
    case Mode of

    pmFirst:
        if (MaxValue = 0) then
            Buf := Format('TCYs', [])
        else
            Buf := Format('%doCg/%doCg', [CurValue, MaxValue])
        ;

    pmProgress:
        if (MaxValue = 0) then
            Buf := Format('%doCg/TCYs', [CurValue])
        else
            Buf := Format('%doCg/%doCg', [CurValue, MaxValue])
        ;

    pmFinish:
        Buf := '';
    end;

    FGauge.MaxValue := MaxValue;
    FGauge.Progress := CurValue;
    ShowStatus(Buf);
end;

//  ---------------------------------------------------------------------------
procedure TForm1.GetFiles(const TopPageUrl: string; MsgBuf: TStrings);

    procedure ShowMsgNum(const Msg: string);begin ShowMsg(Msg, MsgBuf); end;

var
    i, index1, index2: integer;
    Url, Buf, Line: string;
begin
    //  Ny[W擾
    Url := TopPageUrl;
    FMemBuf.Clear;
    ShowMsgNum(Format('擾Jn: %s', [Url]));
    GetHtmlFile(FMemBuf, Url, Progress);
    ShowMsgNum(Format('擾: %d oCg', [FMemBuf.Size]));

    //  Ny[Wۑ
    Buf := DATA_DIR + ExtractUrlFileName(Url);
    ForceDirectories(DATA_DIR);
    FMemBuf.SaveToFile(Buf);
    ShowMsgNum(Format('ۑ: %s', [Buf]));

    //  f[^y[WURL𒊏o
    FDataFileUrl.Clear;
    ShowMsgNum(Format('URLoJn: %s', [Buf]));
    FStrBuf.LoadFromStream(FMemBuf);
    FGauge.MaxValue := FStrBuf.Count;
    for i := 0 to FStrBuf.Count - 1 do
    begin
        FGauge.Progress := i;
        Line := Trim(FStrBuf[i]);
        index1 := Pos('href="', Line);
        if (index1 > 0) then
        begin
            Delete(Line, 1, index1 + Length('href="') - 1);
            index2 := Pos('"', Line);
            if (index2 > 0) then
            begin
                Line := Copy(Line, 1, index2 - 1);
                Buf := ExtractUrlFilePath(Url) + Line;
                FDataFileUrl.Add(Buf);
                ShowMsgNum(Format(': %s', [Buf]));
            end;
        end;
    end;
    FGauge.MaxValue := 0;
    ShowMsgNum(Format('URLo', []));

    //  f[^y[W擾
    ShowMsgNum(Format('f[^y[W擾Jn: S%dt@C', [FDataFileUrl.Count]));
    for i := 0 to FDataFileUrl.Count - 1 do
    begin
        //  f[^y[W擾
        Url := FDataFileUrl[i];
        FMemBuf.Clear;
        ShowMsgNum(Format('(%2d/%2d)擾Jn: %s', [i+1, FDataFileUrl.Count, Url]));
        GetHtmlFile(FMemBuf, Url, Progress);
        ShowMsgNum(Format('       擾: %d oCg', [FMemBuf.Size]));

        //  f[^y[Wۑ
        Buf := DATA_DIR + ExtractUrlFileName(Url);
        ForceDirectories(DATA_DIR);
        FMemBuf.SaveToFile(Buf);
        ShowMsgNum(Format('       ۑ: %s', [Buf]));
    end;
    ShowMsgNum(Format('f[^y[W擾', []));
end;

//------------------------------------------------------------------------------
//  t@CtH_Ƃɂǂ邩
function TForm1.VisitAction(const Path: string; const IsFile: Boolean;
                            const Level: integer; var DigDir: Boolean): Boolean;

    procedure ShowMsgNum(const Msg: string);
    begin
        ShowMsg(Msg, MemPre.Lines);
    end;

var
    Buf: string;
begin
    //  LZ͑ΉȂ̕
    Result := false;

    //  t@C̏ꍇ
    if IsFile then
    begin
        //  Ǎ
        ShowMsgNum(Format('  Ώ: %s', [Path]));
        FStrBuf.LoadFromFile(Path);

        //  K\ɂu
        ShowMsgNum('  HTML^O');
        FRegBuf.Pattern := '<!--(.|\n)*-->|<[^>]*>';
        FStrBuf.Text := FRegBuf.Replace(FStrBuf.Text, ' ');

        //  擪
        FRegBuf.Pattern := '^\s*';
        FStrBuf.Text := FRegBuf.Replace(FStrBuf.Text, '');

        //  
        FRegBuf.Pattern := '\s*$';
        FStrBuf.Text := FRegBuf.Replace(FStrBuf.Text, '');

        //  󔒁Es
        ShowMsgNum('  󔒁Es');
        FRegBuf.Pattern := '\s*('#13#10')+\s*';
        FStrBuf.Text := FRegBuf.Replace(FStrBuf.Text, #13#10);

        //  ۑ
        Buf := WORK_DIR + ExtractFileName(Path);
        ForceDirectories(WORK_DIR);
        FStrBuf.SaveToFile(Buf);
        ShowMsgNum(Format('  ۑ: %s', [Buf]));
    end
    //  tH_̏ꍇ
    else
    begin
        //  @i܂Ȃ肦Ȃ
        DigDir := false;
    end
    ;
end;

//------------------------------------------------------------------------------
//  tϊ(Hxx.xx.xx -> YYYY/MM/DD)
function Conv2DateStr(const S: string): string;
var
    Work: string;
    V: Variant;
begin
    Work := StringReplace(S, '.', '/', [rfReplaceAll]);
    V := Work;
    Result := DateToStr(VarToDateTime(V));
end;

//------------------------------------------------------------------------------
//  MINI LOTO ߋ̃f[^
procedure TForm1.AnalizeLotoOld();
const
    PAT = '[0-9]+';
var
    i: integer;
    Buf: string;
begin
    FRegBuf.Pattern := PAT;
    i := 0;
    while i < FStrBuf.Count do
    begin
        if FRegBuf.Test(FStrBuf[i]) then
        begin
            Buf := 'MINI_LOTO';
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  
            Buf := Buf + ',' + FStrBuf[i];               //  t
            Buf := Buf + ',' + Conv2DateStr(FStrBuf[i]);
                                            Inc(i);      //  t
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  1
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  2
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  3
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  4
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  5
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  BONUS
            FStrBuf2.Add(Buf);
        end
        else
            Inc(i);
    end;
end;

//------------------------------------------------------------------------------
//  LOTO6 ߋ̃f[^
procedure TForm1.AnalizeLoto6Old();
const
    PAT = '[0-9]+';
var
    i: integer;
    Buf: string;
begin
    FRegBuf.Pattern := PAT;
    i := 0;
    while i < FStrBuf.Count do
    begin
        if FRegBuf.Test(FStrBuf[i]) then
        begin
            Buf := 'LOTO6';
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  
            Buf := Buf + ',' + FStrBuf[i];               //  t
            Buf := Buf + ',' + Conv2DateStr(FStrBuf[i]);
                                            Inc(i);      //  t
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  1
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  2
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  3
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  4
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  5
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  6
            Buf := Buf + ',' + FStrBuf[i];  Inc(i);      //  BONUS
            FStrBuf2.Add(Buf);
        end
        else
            Inc(i);
    end;
end;

//------------------------------------------------------------------------------
//  MINI LOTO ŋ߂̃f[^
procedure TForm1.AnalizeLotoNew();
begin

end;

//------------------------------------------------------------------------------
//  LOTO6 ŋ߂̃f[^
procedure TForm1.AnalizeLoto6New();
begin

end;

//------------------------------------------------------------------------------
//  NUMBERS ߋ̃f[^
procedure TForm1.AnalizeNumbersOld();
const
    PAT1 = '';
    PAT2 = '';
var
    i, j, KaiCount: integer;
    Buf3, Buf4: array[0..4] of string;
begin
    i := 0;
    while i < FStrBuf.Count do
    begin
        if (FStrBuf[i] = PAT1) then
        begin
            Inc(i);
            //  
            KaiCount := 0;
            while true do
            begin
                if (FStrBuf[i] <> PAT2) then
                begin
                    Buf3[KaiCount] := 'NUM3' + ',' + FStrBuf[i];
                    Buf4[KaiCount] := 'NUM4' + ',' + FStrBuf[i];
                    Inc(i);
                    Inc(KaiCount);
                end
                else
                begin
                    Inc(i);
                    break;
                end;
            end;
            //  I
            for j := 0 to KaiCount - 1 do
            begin
                Buf3[j] := Buf3[j] + ',' + FStrBuf[i];
                Buf4[j] := Buf4[j] + ',' + FStrBuf[i];
                Buf3[j] := Buf3[j] + ',' + Conv2DateStr(FStrBuf[i]);
                Buf4[j] := Buf4[j] + ',' + Conv2DateStr(FStrBuf[i]);
                Inc(i);
            end;
            //  NUMBERS3
            Inc(i);
            Inc(i);
            for j := 0 to KaiCount - 1 do
            begin
                Buf3[j] := Buf3[j] + ',' + FStrBuf[i];
                Inc(i);
            end;
            //  NUMBERS4
            Inc(i);
            Inc(i);
            for j := 0 to KaiCount - 1 do
            begin
                Buf4[j] := Buf4[j] + ',' + FStrBuf[i];
                Inc(i);
            end;
            //  o
            for j := 0 to KaiCount - 1 do
            begin
                FStrBuf2.Add(Buf3[j]);
                FStrBuf2.Add(Buf4[j]);
            end;
        end
        else Inc(i);
    end;
end;

//------------------------------------------------------------------------------
//  NUMBERS3 ŋ߂̃f[^
procedure TForm1.AnalizeNumbers3New();
begin

end;

//------------------------------------------------------------------------------
//  NUMBERS4 ŋ߂̃f[^
procedure TForm1.AnalizeNumbers4New();
begin

end;

//------------------------------------------------------------------------------
//  t@CtH_Ƃɂǂ邩(͖{)
function TForm1.VisitActionMain(const Path: string; const IsFile: Boolean;
                            const Level: integer; var DigDir: Boolean): Boolean;

    procedure ShowMsgNum(const Msg: string);
    begin
        ShowMsg(Msg, MemMain.Lines);
    end;

type
    EnumLotoType = (ltLoto, ltLoto6, ltLotoH, ltLt6H, ltNum, ltNum3H, ltNum4H);
const
    PATTERN: array[EnumLotoType] of string
    = (
        'loto[0-9]{4}.html'  ,  //  MINI LOTO ߋ̃f[^
        'loto6[0-9]{4}.html' ,  //  LOTO6 ߋ̃f[^
        'loto-h[0-9]{4}.html',  //  MINI LOTO ŋ߂̃f[^
        'lt6-h[0-9]{4}.html' ,  //  LOTO6 ŋ߂̃f[^
        'num[0-9]{4}.html'   ,  //  NUMBERS ߋ̃f[^
        'num3-h[0-9]{4}.html',  //  NUMBERS3 ŋ߂̃f[^
        'num4-h[0-9]{4}.html'   //  NUMBERS4 ŋ߂̃f[^
    );
    PAT_STR: array[EnumLotoType] of string
    = (
        'MINI LOTO ߋ̃f[^'  ,
        'LOTO6 ߋ̃f[^'      ,
        'MINI LOTO ŋ߂̃f[^'  ,
        'LOTO6 ŋ߂̃f[^'      ,
        'NUMBERS ߋ̃f[^',
        'NUMBERS3 ŋ߂̃f[^'   ,
        'NUMBERS4 ŋ߂̃f[^'
    );
var
    Buf: string;
    i: EnumLotoType;
    IsMatched: Boolean;
    ANALYZER: array[EnumLotoType] of procedure of object;
begin
    //  ͊zɃZbg
    ANALYZER[ltLoto]  := AnalizeLotoOld;
    ANALYZER[ltLoto6] := AnalizeLoto6Old;
    ANALYZER[ltLotoH] := AnalizeLotoNew;
    ANALYZER[ltLt6H]  := AnalizeLoto6New;
    ANALYZER[ltNum]   := AnalizeNumbersOld;
    ANALYZER[ltNum3H] := AnalizeNumbers3New;
    ANALYZER[ltNum4H] := AnalizeNumbers4New;

    //  LZ͑ΉȂ̕
    Result := false;

    //  t@C̏ꍇ
    if IsFile then
    begin
        //  Ǎ
        ShowMsgNum(Format('  Ώ: %s', [Path]));
        FStrBuf.LoadFromFile(Path);

        //  t@Co
        Buf := ExtractFileName(Path);

        //  啶ʂȂ
        FRegBuf.IgnoreCase := true;

        //  RRɏo͂Ă炤
        FStrBuf2.Clear;

        //  t@C̎ޔ
        for i := Low(EnumLotoType) to High(EnumLotoType) do
        begin
            FRegBuf.Pattern := PATTERN[i];
            IsMatched := FRegBuf.Test(Buf);
            if IsMatched then
            begin
                ShowMsgNum(Format('  茋: %10s ... %s', [Buf, PAT_STR[i]]));
                ANALYZER[i]();
                break;
            end;
        end;

        if IsMatched then
        begin
            //  ۑ
            Buf := RSLT_DIR + ChangeFileExt(ExtractFileName(Path), '.txt');
            ForceDirectories(RSLT_DIR);
            FStrBuf2.SaveToFile(Buf);
            ShowMsgNum(Format('  ۑ: %s', [Buf]));
        end
        else
            ShowMsgNum(Format('  : %s', [Buf]))
        ;
    end
    //  tH_̏ꍇ
    else
    begin                                           
        //  @i܂Ȃ肦Ȃ
        DigDir := false;
    end
    ;
end;

//  ---------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    case PageMain.ActivePageIndex of
    //  y[W̎擾
    0:  begin
            case Page1.ActivePageIndex of
            0:  GetFiles(LblUrlNum.Caption, MemNumbers.Lines);
            1:  GetFiles(LblUrlLoto.Caption, MemLoto.Lines);
            end;
        end;
    //  ͑O
    1:  begin
            MemPre.Lines.Clear;
            ShowMsg('͑OJn', MemPre.Lines);
            VisitDirectory(DATA_DIR, 0, VisitAction);
            ShowMsg('͑O', MemPre.Lines);
        end;

    //  
    2:  begin
            MemMain.Lines.Clear;
            ShowMsg('͊Jn', MemMain.Lines);
            VisitDirectory(WORK_DIR, 0, VisitActionMain);
            ShowMsg('͊', MemMain.Lines);
        end;

    end;
end;
//  ---------------------------------------------------------------------------
initialization
    DATA_DIR := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'dat\';
    WORK_DIR := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'work\';
    RSLT_DIR := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'result\';
finalization

end.

